您的位置:首页 > 其它

poj 2184 Cow Exhibition (01背包)

2017-02-11 00:28 375 查看
Description

"Fat and docile, big and dumb, they look so stupid, they aren't much 

fun..." 

- Cows with Guns by Dana Lyons 

The cows want to prove to the public that they are both smart and fun. In order to do this, Bessie has organized an exhibition that will be put on by the cows. She has given each of the N (1 <= N <= 100) cows a thorough interview and determined two values for
each cow: the smartness Si (-1000 <= Si <= 1000) of the cow and the funness Fi (-1000 <= Fi <= 1000) of the cow. 

Bessie must choose which cows she wants to bring to her exhibition. She believes that the total smartness TS of the group is the sum of the Si's and, likewise, the total funness TF of the group is the sum of the Fi's. Bessie wants to maximize the sum of TS
and TF, but she also wants both of these values to be non-negative (since she must also show that the cows are well-rounded; a negative TS or TF would ruin this). Help Bessie maximize the sum of TS and TF without letting either of these values become negative. 

Input

* Line 1: A single integer N, the number of cows 

* Lines 2..N+1: Two space-separated integers Si and Fi, respectively the smartness and funness for each cow. 

Output

* Line 1: One integer: the optimal sum of TS and TF such that both TS and TF are non-negative. If no subset of the cows has non-negative TS and non- negative TF, print 0. 

Sample Input
5
-5 7
8 -6
6 -3
2 1
-8 -5

Sample Output
8

Hint

OUTPUT DETAILS: 

Bessie chooses cows 1, 3, and 4, giving values of TS = -5+6+2 = 3 and TF 

= 7-3+1 = 5, so 3+5 = 8. Note that adding cow 2 would improve the value 

of TS+TF to 10, but the new value of TF would be negative, so it is not 

allowed. 

Source
USACO 2003 Fall

题意:给出num(num<=100)头奶牛的S和F值(-1000<=S,F<=1000),要求在这几头奶牛中选出若干头,使得在其总S值TS和总F值TF均不为负的前提下,求最大的TS+TF值;
思路:这道题的关键有两点:一是将smartness看作花费、将funness看作价值,从而转化为01背包;二是对负值的处理,引入一个shift来表示“0”,这里的shift一定要大于每一个负smartness绝对值的和,另外在遍历cost[]的时候如果cost[i]>0,显然时从开的数组的最大值maxm
开始往下减,如果cost[i]<0,则是从0(是0,不是shift)开始往上增加。大于0的情况容易想到,小于0的情况比较费解,需要仔细思考。

  考虑只有一只牛,它的smartness为-x(x>0),funness为y(y>0),由于将dp[shift]赋初值为0,其它的dp[]赋初值为负无穷,所以有dp[shift-(-x)]+y>dp[shift],即dp[x]会被赋为dp[shift-(-x)]+y即y(
dp[x]=max(dp[shift-(-x)]+y,dp[shift])  ),由于x小于shift,表示花费为负,所以在最后遍历最大值的时候,这个值根本不会被遍历。

  再考虑前面已经有一些牛,此时dp[shift+x]=y(x>0,y>0)现在出现了一只为-a b(a>0,b>0)的牛,那么dp[shift+X-a]会被赋为dp[shift+x-a-(-a)]+b=dp[shift+x]+b=y+b;最终遍历的时候,如果取最后一只牛,和为x-a+y+b,如果不取,和为x+y,所以最大值究竟是谁取决于b-a的正负。
  综上所述,这是一种满足题目要求的方法,所以在cost[i]<0的时候时从0开始往上增加。

代码:
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int INF=0x3f3f3f3f;
const int N=105;
const int M=210000;
int s
,f
;
int dp[M];
int high=100000;
int main()
{
int t;
while(~scanf("%d",&t))
{
for(int i=0;i<t;i++)
scanf("%d%d",&s[i],&f[i]);
memset(dp,-INF,sizeof(dp));
dp[high]=0;
for(int i=0;i<t;i++)
{
if(s[i]>0)
for(int j=M-1;j>=s[i];j--)
dp[j]=max(dp[j],dp[j-s[i]]+f[i]);
else
for(int j=0;j<M+s[i];j++)
dp[j]=max(dp[j],dp[j-s[i]]+f[i]);
}
int ans=0;
for(int i=high;i<M;i++)
{
if(ans<i-high+dp[i]&&dp[i]>=0)
ans=max(ans,i-high+dp[i]);
}
printf("%d\n",ans);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: